from fenics import *
import matplotlib.pyplot as plt

mesh = UnitSquareMesh(32 , 32)

V = FunctionSpace(mesh , "Lagrange", 1)
u = TrialFunction(V)
v = TestFunction(V)
f = Expression ("x[0]*x[1]", degree =2)

a = dot( grad(u), grad(v))*dx
L = f*v*dx

bc = DirichletBC (V, 0.0, DomainBoundary ())

u0= Function (V)
solve (a == L, u0, bc)

p=plot(u0)
plt.show()