from fenics import *
import matplotlib.pyplot as plt

mesh = UnitSquareMesh(32 , 32)

V = FunctionSpace(mesh , "Lagrange", 1)
u = TrialFunction(V)
v = TestFunction(V)
f = Expression("1000.*x[0]*x[1]", degree =2)

a = dot( grad(u), grad(v))*dx
L = f*v*dx

bc = DirichletBC (V, 0.0, DomainBoundary ())

u0= Function (V)
solve (a == L, u0, bc)

p=plot(u0)
plt.colorbar(p)
plt.show()

V = FunctionSpace(mesh , "Lagrange", 2)
u = TrialFunction(V)
v = TestFunction(V)
f = Expression("1000.*x[0]*x[1]", degree =2)

a = dot( grad(u), grad(v))*dx
L = f*v*dx

bc = DirichletBC (V, 0.0, DomainBoundary ())

u1= Function (V)
solve (a == L, u1, bc)

ut = project(u0, V)
p=plot(u1-ut)
plt.colorbar(p)
plt.show()

V = FunctionSpace(mesh , "Lagrange", 1)
u = TrialFunction(V)
v = TestFunction(V)
f = Expression ("1000.*x[0]*x[1]", degree =1)

a = dot( grad(u), grad(v))*dx
L = f*v*dx

bc = DirichletBC (V, 0.0, DomainBoundary ())

u2= Function (V)
solve (a == L, u2, bc)

ut = project(u1, V)
p=plot(u2-ut)
plt.colorbar(p)
plt.show()

V = FunctionSpace(mesh , "Lagrange", 2)
u = TrialFunction(V)
v = TestFunction(V)
f = Expression ("1000.*x[0]*x[1]", degree =3)

a = dot( grad(u), grad(v))*dx
L = f*v*dx

bc = DirichletBC (V, 0.0, DomainBoundary ())

u3= Function (V)
solve (a == L, u3, bc)

ut = project(u1, V)
p=plot(u3-ut)
plt.colorbar(p)
plt.show()