from fenics import *
import matplotlib.pyplot as plt

mesh = UnitSquareMesh(8 , 8)

V = FunctionSpace(mesh , "Lagrange", 1)
u = TrialFunction(V)
v = TestFunction(V)
f = Expression (...)

a = ...

L = ...
# Define Dirichlet boundary conditions
# Lower boundary
tol = 1E-14
def lower_boundary(x, on_boundary):
    return on_boundary and x[1] < tol

bcd = DirichletBC(V, Constant(0.0), lower_boundary)

# Upper boundary
def upper_boundary(x, on_boundary):
    return on_boundary and x[1] > 1.-tol
	
bcu = ...

# Another formulation for the same
# left boundary
class LeftBoundary(SubDomain):
    def inside(self, x, on_boundary):
        tol = DOLFIN_EPS
        return on_boundary and x[0] < tol

# right boundary
class RightBoundary(SubDomain):
    def inside(self, x, on_boundary):
        tol = DOLFIN_EPS
        return on_boundary and ...	
	
left_boundary = LeftBoundary()        
right_boundary = RightBoundary()

bcl = DirichletBC(V, Expression("x[1]*x[1]", degree =1), left_boundary)
bcr = ...

bc = [bcd, bcu,...]

u0= Function(V)
solve (a == L, u0, bc)

p=plot(u0)
plt.colorbar(p)
plt.show()

sols = Expression("x[1]*x[1] + 2.*x[0]*x[0]*x[1]*x[1]",degree=3)
sol = project(sols, V)

p=plot(u0-sols)
plt.colorbar(p)
plt.show()